diff -uwr sourceold/scripts/PhysicsSceneClass.h source/scripts/PhysicsSceneClass.h
--- sourceold/scripts/PhysicsSceneClass.h	2011-10-11 21:48:58.233398400 +0800
+++ source/scripts/PhysicsSceneClass.h	2012-04-14 04:09:46.643554600 +0800
@@ -112,6 +112,14 @@
 	SHADERS_API bool Intersection_Test(PhysMeshIntersectionTestClass & meshtest,bool use_collision_region = false);
 	SHADERS_API bool Intersection_Test(const AABoxClass & box,int collision_group,int collision_type,bool use_collision_region = false);
 	SHADERS_API bool Intersection_Test(const OBBoxClass & box,int collision_group,int collision_type,bool use_collision_region = false);
+	bool Real_Cast_Ray(PhysRayCollisionTestClass & raytest,bool use_collision_region = false);
+	bool Real_Cast_AABox(PhysAABoxCollisionTestClass & boxtest,bool use_collision_region = false);
+	bool Real_Cast_OBBox(PhysOBBoxCollisionTestClass & boxtest,bool use_collision_region = false);
+	bool Real_Intersection_Test1(PhysAABoxIntersectionTestClass & boxtest,bool use_collision_region = false);
+	bool Real_Intersection_Test2(PhysOBBoxIntersectionTestClass & boxtest,bool use_collision_region = false);
+	bool Real_Intersection_Test3(PhysMeshIntersectionTestClass & meshtest,bool use_collision_region = false);
+	bool Real_Intersection_Test4(const AABoxClass & box,int collision_group,int collision_type,bool use_collision_region = false);
+	bool Real_Intersection_Test5(const OBBoxClass & box,int collision_group,int collision_type,bool use_collision_region = false);
 	void Force_Dynamic_Objects_Awake(const AABoxClass & box);
 	void Collect_Objects(const Vector3 & point,bool static_objs, bool dynamic_objs,MultiListClass<PhysClass> * list);
 	void Collect_Objects(const AABoxClass & box,bool static_objs, bool dynamic_objs,MultiListClass<PhysClass> * list);
@@ -258,7 +266,7 @@
 	virtual void Destroy_Iterator(SceneIterator *) {}
 	virtual void Register(RenderObjClass * obj,RegType for_what);
 	virtual void Unregister(RenderObjClass * obj,RegType for_what);
-	void Get_Level_Extents (Vector3 &min, Vector3 &max);
+	SHADERS_API void Get_Level_Extents (Vector3 &min, Vector3 &max);
 	void Enable_Debug_Display(bool onoff) { DebugDisplayEnabled = onoff; }
 	bool Is_Debug_Display_Enabled(void) { return DebugDisplayEnabled; }
 	void Enable_Projector_Debug_Display(bool onoff) { ProjectorDebugDisplayEnabled = onoff; }
diff -uwr sourceold/scripts/PowerPlantGameObj.h source/scripts/PowerPlantGameObj.h
--- sourceold/scripts/PowerPlantGameObj.h	2011-10-11 21:48:42.026367100 +0800
+++ source/scripts/PowerPlantGameObj.h	2012-05-23 11:14:11.018554600 +0800
@@ -20,7 +20,7 @@
 	~PowerPlantGameObj (void);
 	virtual	void					Init( void );
 	void								Init (const PowerPlantGameObjDef & definition);
-	const PowerPlantGameObjDef &	Get_Definition (void) const;
+	SCRIPTS_API const PowerPlantGameObjDef &	Get_Definition (void) const;
 	PowerPlantGameObj *				As_PowerPlantGameObj (void)	{ return this; }
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/PowerPlantGameObjDef.h source/scripts/PowerPlantGameObjDef.h
--- sourceold/scripts/PowerPlantGameObjDef.h	2011-10-11 21:48:40.079101500 +0800
+++ source/scripts/PowerPlantGameObjDef.h	2012-05-06 16:37:05.200109400 +0800
@@ -22,6 +22,9 @@
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
 	const PersistFactoryClass &	Get_Factory (void) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (PowerPlantGameObjDef, BuildingGameObjDef);
 protected:
 	void					Load_Variables (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/PowerupGameObjDef.h source/scripts/PowerupGameObjDef.h
--- sourceold/scripts/PowerupGameObjDef.h	2011-10-11 21:48:36.038085900 +0800
+++ source/scripts/PowerupGameObjDef.h	2012-05-06 16:37:05.212804700 +0800
@@ -28,6 +28,9 @@
 	bool Is_Persistant() const {return Persistent;}
 	bool Is_Always_Allow_Grant() const {return AlwaysAllowGrant;}
 	int Get_Grant_Sound() const {return GrantSoundID;}
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (PowerUpGameObjDef, SimpleGameObjDef);
 public:
 	int											GrantShieldType;
Only in source/scripts: PresetMgr.cpp
Only in source/scripts: PresetMgr.h
diff -uwr sourceold/scripts/PurchaseSettingsDefClass.h source/scripts/PurchaseSettingsDefClass.h
--- sourceold/scripts/PurchaseSettingsDefClass.h	2011-10-25 15:39:17.330078100 +0800
+++ source/scripts/PurchaseSettingsDefClass.h	2012-05-06 16:37:05.226476600 +0800
@@ -18,6 +18,8 @@
 #endif
 #include "NetworkObjectClass.h"
 #include "ExtendedNetworkObject.h"
+#include "BuildingGameObjDef.h"
+using namespace BuildingConstants;
 #define PTTEAM(t) (t?0:1) //Convert a normal team into a PT team
 class PurchaseSettingsDefClass abstract : public DefinitionClass, public NetworkObjectClass  {
 public:
@@ -46,6 +48,9 @@
 	uint32 Get_Class_ID() const;
 	PersistClass *Create() const;
 	static SCRIPTS_API PurchaseSettingsDefClass *Find_Definition(TYPE type,TEAM team);
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE(PurchaseSettingsDefClass,DefinitionClass);
 	void Delete(void)
 	{
@@ -95,6 +100,34 @@
 	{
 		return type;
 	}
+	int Get_Tech_Level(int index)
+	{
+		return TechLevel[index];
+	}
+	bool Get_Factory_Not_Required(int index)
+	{
+		return FactoryNotRequired[index];
+	}
+	BuildingType Get_Factory_Building(int index)
+	{
+		return Factory[index];
+	}
+	BuildingType Get_Tech_Building(int index)
+	{
+		return TechBuilding[index];
+	}
+	void Set_Tech_Level(int index,int level)
+	{
+		TechLevel[index] = level;
+	}
+	void Set_Factory_Building(int index,BuildingType type)
+	{
+		Factory[index] = type;
+	}
+	void Set_Tech_Building(int index,BuildingType type)
+	{
+		TechBuilding[index] = type;
+	}
 	bool Get_Hidden(int index)
 	{
 		return Hidden[index];
@@ -160,6 +193,10 @@
 	bool Hidden[10];
 	bool Disabled[10];
 	bool Busy[10];
+	int TechLevel[10];
+	BuildingType Factory[10];
+	BuildingType TechBuilding[10];
+	bool FactoryNotRequired[10];
 	int altpresetids[10][3];
 	StringClass alttextures[10][3];
 	bool PageHidden;
Only in source/scripts: Random2Class.cpp
diff -uwr sourceold/scripts/Random2Class.h source/scripts/Random2Class.h
--- sourceold/scripts/Random2Class.h	2011-10-11 21:48:09.370117100 +0800
+++ source/scripts/Random2Class.h	2012-05-01 21:00:32.585937500 +0800
@@ -103,6 +103,8 @@
 		int mti;
 };
 #ifndef TTLE_EXPORTS
+#ifndef TDBEDIT
 extern REF_DECL2(FreeRandom, CRandom);
 #endif
 #endif
+#endif
Only in source/scripts: Random3Class.cpp
Only in source/scripts: Random3Class.h
Only in source/scripts: RandomClass.cpp
Only in source/scripts: RandomClass.h
diff -uwr sourceold/scripts/RefineryGameObjDef.h source/scripts/RefineryGameObjDef.h
--- sourceold/scripts/RefineryGameObjDef.h	2011-10-11 21:47:47.846679600 +0800
+++ source/scripts/RefineryGameObjDef.h	2012-05-06 16:37:05.239171900 +0800
@@ -25,10 +25,9 @@
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
 	const PersistFactoryClass &	Get_Factory (void) const;
-	int Get_Harvester_ID() const
-	{
-		return HarvesterDefID;
-	}
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (RefineryGameObjDef, BuildingGameObjDef);
 protected:
 	void					Load_Variables (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/RepairBayGameObj.h source/scripts/RepairBayGameObj.h
--- sourceold/scripts/RepairBayGameObj.h	2011-10-11 21:44:44.096679600 +0800
+++ source/scripts/RepairBayGameObj.h	2012-05-23 11:14:19.778320300 +0800
@@ -26,7 +26,7 @@
 	~RepairBayGameObj (void);
 	virtual	void						Init( void );
 	void									Init (const RepairBayGameObjDef & definition);
-	const RepairBayGameObjDef &	Get_Definition (void) const;
+	SCRIPTS_API const RepairBayGameObjDef &	Get_Definition (void) const;
 	RepairBayGameObj *				As_RepairBayGameObj (void)	{ return this; }
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/RepairBayGameObjDef.h source/scripts/RepairBayGameObjDef.h
--- sourceold/scripts/RepairBayGameObjDef.h	2011-10-11 21:44:42.151367100 +0800
+++ source/scripts/RepairBayGameObjDef.h	2012-05-06 16:37:05.252843700 +0800
@@ -26,6 +26,9 @@
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
 	const PersistFactoryClass &	Get_Factory (void) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (RepairBayGameObjDef, BuildingGameObjDef);
 protected:
 	void					Load_Variables (ChunkLoadClass &cload);
Only in source/scripts: SCAnnouncement.h
diff -uwr sourceold/scripts/SamSiteGameObj.h source/scripts/SamSiteGameObj.h
--- sourceold/scripts/SamSiteGameObj.h	2011-10-11 21:44:36.515625000 +0800
+++ source/scripts/SamSiteGameObj.h	2012-05-23 11:14:44.942382800 +0800
@@ -26,7 +26,7 @@
 	~SamSiteGameObj();
 	void Init();
 	void Init(const SamSiteGameObjDef &);
-	const SamSiteGameObjDef & Get_Definition( void ) const ;
+	SCRIPTS_API const SamSiteGameObjDef & Get_Definition( void ) const ;
 	bool Save(ChunkSaveClass &csave);
 	bool Load(ChunkLoadClass &cload);
 	void Export_Frequent(BitStreamClass &BitStream);
diff -uwr sourceold/scripts/SamSiteGameObjDef.h source/scripts/SamSiteGameObjDef.h
--- sourceold/scripts/SamSiteGameObjDef.h	2011-10-11 21:44:34.754882800 +0800
+++ source/scripts/SamSiteGameObjDef.h	2012-05-06 16:37:05.265539100 +0800
@@ -21,6 +21,10 @@
 	bool Load(ChunkLoadClass &cload);
 	uint32 Get_Class_ID() const;
 	PersistClass *Create() const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+	virtual void                        DumpPhys (FileClass &file);
+#endif
 	DECLARE_EDITABLE(SamSiteGameObjDef,SmartGameObjDef);
 	friend class PresetDump;
 };
diff -uwr sourceold/scripts/ScriptManager.h source/scripts/ScriptManager.h
--- sourceold/scripts/ScriptManager.h	2011-03-28 17:16:44.035156200 +0800
+++ source/scripts/ScriptManager.h	2012-05-02 02:01:20.366210900 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef TT_INCLUDE_SCRIPTMANAGER_H
 #define TT_INCLUDE_SCRIPTMANAGER_H
 #include "engine_vector.h"
diff -uwr sourceold/scripts/ScriptZoneGameObjDef.h source/scripts/ScriptZoneGameObjDef.h
--- sourceold/scripts/ScriptZoneGameObjDef.h	2011-10-11 21:44:14.845703100 +0800
+++ source/scripts/ScriptZoneGameObjDef.h	2012-05-06 16:37:05.291906200 +0800
@@ -39,6 +39,9 @@
 	const Vector3 &Get_Color() const {return Color;}
 	ZoneConstants::ZoneType Get_Type() const {return ZoneType;}
 	int Get_Preset_ID() const {return PresetID;}
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (ScriptZoneGameObjDef, ScriptableGameObjDef);
 protected:
 	ZoneConstants::ZoneType ZoneType;
diff -uwr sourceold/scripts/ScriptableGameObj.h source/scripts/ScriptableGameObj.h
--- sourceold/scripts/ScriptableGameObj.h	2011-10-11 21:44:26.625000000 +0800
+++ source/scripts/ScriptableGameObj.h	2012-05-12 19:48:12.908203100 +0800
@@ -64,7 +64,7 @@
 	virtual	void	Think();
 	virtual	void	Post_Think();
 	virtual	void		Get_Position(Vector3 * set_pos) const		= 0;
-	void Add_Observer( GameObjObserverClass * observer );
+	void SCRIPTS_API Add_Observer( GameObjObserverClass * observer );
 	void SCRIPTS_API Remove_Observer( GameObjObserverClass * observer );
 	void Remove_All_Observers(void);
 	void Start_Observers( void );
diff -uwr sourceold/scripts/ScriptableGameObjDef.h source/scripts/ScriptableGameObjDef.h
--- sourceold/scripts/ScriptableGameObjDef.h	2011-10-11 21:44:24.187500000 +0800
+++ source/scripts/ScriptableGameObjDef.h	2012-05-06 16:37:05.279210900 +0800
@@ -18,6 +18,9 @@
 	ScriptableGameObjDef( void );
 	virtual bool								Save( ChunkSaveClass &csave );
 	virtual bool								Load( ChunkLoadClass &cload );
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE( ScriptableGameObjDef, BaseGameObjDef );
 	DynamicVectorClass<StringClass>		ScriptNameList; // 001C
 	DynamicVectorClass<StringClass>		ScriptParameterList; // 0034
diff -uwr sourceold/scripts/SimpleGameObjDef.h source/scripts/SimpleGameObjDef.h
--- sourceold/scripts/SimpleGameObjDef.h	2011-10-11 21:43:54.694335900 +0800
+++ source/scripts/SimpleGameObjDef.h	2012-05-06 16:37:05.310460900 +0800
@@ -22,6 +22,10 @@
 	PersistClass *Create() const;
 	bool Get_Is_Editor_Object() const { return IsEditorObject; }
 	int Get_Player_Terminal_Type() const {return PlayerTerminalType;}
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+	virtual void                        DumpPhys (FileClass &file);
+#endif
 	DECLARE_EDITABLE( SimpleGameObjDef, PhysicalGameObjDef );
 protected:
 	bool IsEditorObject; // 00A5
diff -uwr sourceold/scripts/SmartGameObj.h source/scripts/SmartGameObj.h
--- sourceold/scripts/SmartGameObj.h	2011-10-11 21:43:45.486328100 +0800
+++ source/scripts/SmartGameObj.h	2012-05-23 11:29:02.688476500 +0800
@@ -58,8 +58,8 @@
 	virtual void Set_Control_Owner(int control_owner)		{ ControlOwner = control_owner; }
 	PlayerDataClass * Get_Player_Data( void )						{ return PlayerData; }
 	void Set_Player_Data( PlayerDataClass * player_data );
-	bool Has_Player(void);
-	bool Is_Human_Controlled(void);
+	SCRIPTS_API bool Has_Player(void);
+	SCRIPTS_API bool Is_Human_Controlled(void);
 	bool Is_Controlled_By_Me(void);
 	virtual	void	Apply_Control( void );
 	virtual	void		Think();
diff -uwr sourceold/scripts/SmartGameObjDef.h source/scripts/SmartGameObjDef.h
--- sourceold/scripts/SmartGameObjDef.h	2011-10-11 21:43:42.815429600 +0800
+++ source/scripts/SmartGameObjDef.h	2012-05-06 16:37:05.324132800 +0800
@@ -26,6 +26,9 @@
 	virtual bool								Save( ChunkSaveClass &csave );
 	virtual bool								Load( ChunkLoadClass &cload );
 	bool Is_Stealthed() const {return IsStealthUnit;}
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE( SmartGameObjDef, ArmedGameObjDef );
 protected:
 	float											SightRange;
diff -uwr sourceold/scripts/SoldierFactoryGameObj.h source/scripts/SoldierFactoryGameObj.h
--- sourceold/scripts/SoldierFactoryGameObj.h	2011-10-11 21:43:39.913085900 +0800
+++ source/scripts/SoldierFactoryGameObj.h	2012-05-23 11:15:03.379882800 +0800
@@ -20,7 +20,7 @@
 	~SoldierFactoryGameObj (void);
 	virtual	void					Init( void );
 	void								Init (const SoldierFactoryGameObjDef & definition);
-	const SoldierFactoryGameObjDef &	Get_Definition (void) const;
+	SCRIPTS_API const SoldierFactoryGameObjDef &	Get_Definition (void) const;
 	SoldierFactoryGameObj *				As_SoldierFactoryGameObj (void)	{ return this; }
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/SoldierFactoryGameObjDef.h source/scripts/SoldierFactoryGameObjDef.h
--- sourceold/scripts/SoldierFactoryGameObjDef.h	2011-10-11 21:43:37.670898400 +0800
+++ source/scripts/SoldierFactoryGameObjDef.h	2012-05-06 16:37:05.337804700 +0800
@@ -22,6 +22,9 @@
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
 	const PersistFactoryClass &	Get_Factory (void) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (SoldierFactoryGameObjDef, BuildingGameObjDef);
 protected:
 	void					Load_Variables (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/SoldierGameObj.h source/scripts/SoldierGameObj.h
--- sourceold/scripts/SoldierGameObj.h	2012-02-23 16:37:06.592773400 +0800
+++ source/scripts/SoldierGameObj.h	2012-05-23 11:25:50.666992100 +0800
@@ -17,13 +17,14 @@
 #include "SmartGameObj.h"
 #include "PhysClass.h"
 #include "ArmorWarheadManager.h"
+#include "TransitionGameObjDef.h"
 class TransitionInstanceClass;
 class RenderObjClass;
 class SimpleAnimControlClass;
 class TransitionCompletionDataStruct
 {
 public:
-	int Type;
+	TransitionDataClass::StyleType Type;
 	ReferencerClass Vehicle;
 	bool Save(ChunkSaveClass &csave);
 	bool Load(ChunkLoadClass &cload);
@@ -44,7 +45,7 @@
 	void	Init( const SoldierGameObjDef & definition );
 	void	Copy_Settings( const SoldierGameObjDef & definition );
 	void	SCRIPTS_API Re_Init( const SoldierGameObjDef & definition );
-	const SoldierGameObjDef & Get_Definition( void ) const ;
+	SCRIPTS_API const SoldierGameObjDef & Get_Definition( void ) const ;
 	virtual	bool	Save( ChunkSaveClass & csave );
 	virtual	bool	Load( ChunkLoadClass & cload );
 	virtual	void	On_Post_Load( void );
@@ -58,6 +59,12 @@
 	virtual	void	Apply_Damage( const OffenseObjectClass & damager, float scale = 1.0f, int alternate_skin = -1 );
    virtual	void	Apply_Damage_Extended( const OffenseObjectClass & offense, float scale = 1.0f,
 			const	Vector3 & direction = Vector3( 0,0,0 ), const char * collision_box_name = NULL );
+
+  /*! A clone of Apply_Damage() which ignores whether the soldier is currently in a vehicle - this
+  * is necessary for dp88_remoteControlConsole to kill the driver of a remote control vehicle when
+  * the 'dummy' version of the driver is killed. */
+  virtual void Apply_Damage_IgnoreVehicleCheck( const OffenseObjectClass & damager, float scale = 1.0f, int alternate_skin = -1 );
+
 	virtual	void	Completely_Damaged( const OffenseObjectClass & damager ) {}
 	virtual CollisionReactionType	Collision_Occurred( const CollisionEventClass & event );
 	virtual	Vector3	Get_Bullseye_Position( void );
@@ -81,7 +88,7 @@
 	void				Interpret_Sc_State_Data(HumanStateClass::HumanStateType state, 
 							int sub_state, LPCSTR trans_name, const Vector3 & velocity, const Vector3 & sc_position);
 	int				Tally_Vis_Visible_Soldiers(void);
-	bool				Is_In_Elevator(void);
+	SCRIPTS_API bool				Is_In_Elevator(void);
 	virtual void	Export_Creation( BitStreamClass &packet );
 	virtual void	Import_Creation( BitStreamClass &packet );
 	virtual void	Export_Rare( BitStreamClass &packet );
diff -uwr sourceold/scripts/SoldierGameObjDef.h source/scripts/SoldierGameObjDef.h
--- sourceold/scripts/SoldierGameObjDef.h	2012-02-13 17:49:26.127351500 +0800
+++ source/scripts/SoldierGameObjDef.h	2012-05-06 16:37:05.348546900 +0800
@@ -30,9 +30,13 @@
 	virtual bool								Load( ChunkLoadClass &cload );
 	virtual const PersistFactoryClass &	Get_Factory( void ) const;
 	DialogueClass *							Get_Dialog_List( void )			{ return DialogList; }
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+	virtual void                        DumpPhys (FileClass &file);
+#endif
 	DECLARE_EDITABLE( SoldierGameObjDef, SmartGameObjDef );
-	float Get_Skeleton_Height() {return SkeletonHeight;};
-	float Get_Skeleton_Width() {return SkeletonWidth;};
+	float Get_Skeleton_Height() const {return SkeletonHeight;};
+	float Get_Skeleton_Width() const {return SkeletonWidth;};
 	bool Is_Spy() const {return IsSpy;}
 protected:
 	float											TurnRate;
diff -uwr sourceold/scripts/SoundBufferClass.h source/scripts/SoundBufferClass.h
--- sourceold/scripts/SoundBufferClass.h	2011-10-11 21:43:30.267578100 +0800
+++ source/scripts/SoundBufferClass.h	2012-04-14 04:09:47.430664000 +0800
@@ -23,6 +23,9 @@
 	uint32 uBits;      // 52
 	uint32 uChannels;  // 56
 	uint32 uType;      // 60
+	unsigned int flag;
+	int cachecount;
+	SoundBufferClass();
 	virtual ~SoundBufferClass();
 	virtual bool        Load_From_File   (const char* cFile);
 	virtual bool        Load_From_File   (FileClass& xFile);
@@ -38,7 +41,19 @@
 	virtual uint32      Get_Type         () const;
 	virtual bool        Is_Streaming     () const;
 	virtual void        Free_Buffer      ();
-	virtual void        Determine_Stats  (char*);
+	virtual void        Determine_Stats  (char *stats);
+};
+
+class StreamSoundBufferClass : public SoundBufferClass {
+public:
+	StreamSoundBufferClass();
+	virtual ~StreamSoundBufferClass();
+	virtual bool        Load_From_File   (const char* cFile);
+	virtual bool        Load_From_File   (FileClass& xFile);
+	virtual bool        Load_From_Memory (const char* cBuffer, uint32 uLength);
+	virtual bool        Is_Streaming     () const;
+	virtual void        Free_Buffer      ();
+	virtual bool        Load_From_File(void *handle, uint32 u1, uint32 u2);
 };
 
 #endif
\ No newline at end of file
diff -uwr sourceold/scripts/SpecialEffectsGameObj.h source/scripts/SpecialEffectsGameObj.h
--- sourceold/scripts/SpecialEffectsGameObj.h	2011-10-11 21:43:25.304687500 +0800
+++ source/scripts/SpecialEffectsGameObj.h	2012-05-23 11:15:20.002929600 +0800
@@ -20,7 +20,7 @@
 	const PersistFactoryClass &Get_Factory() const;
 	void Init();
 	void Init(const SpecialEffectsGameObjDef &);
-	const SpecialEffectsGameObjDef & Get_Definition( void ) const ;
+	SCRIPTS_API const SpecialEffectsGameObjDef & Get_Definition( void ) const ;
 	bool Save(ChunkSaveClass &csave);
 	bool Load(ChunkLoadClass &cload);
 	void Do_Effect();
diff -uwr sourceold/scripts/SpecialEffectsGameObjDef.h source/scripts/SpecialEffectsGameObjDef.h
--- sourceold/scripts/SpecialEffectsGameObjDef.h	2011-10-11 21:43:23.110351500 +0800
+++ source/scripts/SpecialEffectsGameObjDef.h	2012-05-06 16:37:05.358312500 +0800
@@ -21,6 +21,10 @@
 	bool Load(ChunkLoadClass &cload);
 	uint32 Get_Class_ID() const;
 	PersistClass *Create() const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+	virtual void                        DumpPhys (FileClass &file);
+#endif
 	DECLARE_EDITABLE(SpecialEffectsGameObjDef,PhysicalGameObjDef);
 private:
 	void Save_Variables(ChunkSaveClass &csave);
diff -uwr sourceold/scripts/TeamPurchaseSettingsDefClass.h source/scripts/TeamPurchaseSettingsDefClass.h
--- sourceold/scripts/TeamPurchaseSettingsDefClass.h	2011-10-11 21:41:45.217773400 +0800
+++ source/scripts/TeamPurchaseSettingsDefClass.h	2012-05-06 16:37:05.368078100 +0800
@@ -35,6 +35,9 @@
 	uint32 Get_Class_ID() const;
 	virtual PersistClass *Create() const;
 	static SCRIPTS_API TeamPurchaseSettingsDefClass *Get_Definition(TEAM team);
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE(TeamPurchaseSettingsDefClass,DefinitionClass);
 	void Delete(void)
 	{
diff -uwr sourceold/scripts/TransitionGameObj.h source/scripts/TransitionGameObj.h
--- sourceold/scripts/TransitionGameObj.h	2011-10-11 21:41:35.694335900 +0800
+++ source/scripts/TransitionGameObj.h	2012-05-23 11:15:26.267578100 +0800
@@ -22,21 +22,24 @@
 	Matrix3D Transform;
 	int LadderIndex;
 public:
+	const PersistFactoryClass &Get_Factory() const;
 	TransitionGameObj();
 	~TransitionGameObj();
-	void On_Post_Load();
-	const PersistFactoryClass &Get_Factory() const;
-	bool Save(ChunkSaveClass &csave);
-	bool Load(ChunkLoadClass &cload);
 	void Init();
 	void Init(const TransitionGameObjDef &definition);
-	const TransitionGameObjDef & Get_Definition( void ) const ;
+	SCRIPTS_API const TransitionGameObjDef & Get_Definition( void ) const ;
+	bool Save(ChunkSaveClass &csave);
+	bool Load(ChunkLoadClass &cload);
+	void On_Post_Load();
 	void Set_Transform(const Matrix3D &tm);
 	const Matrix3D &Get_Transform() const;
-	DynamicVectorClass<TransitionInstanceClass *> &Get_Transitions() {return Transitions;}
-	const DynamicVectorClass<TransitionInstanceClass *> &Get_Transitions() const {return Transitions;}
 	void Create_Transitions();
 	void Destroy_Transitions();
+	void Update_Transitions();
+	void Set_Ladder_Index();
+	int Get_Transition_Count() {return Transitions.Count();};
+	TransitionInstanceClass *Get_Transition(int trans) {return Transitions[trans];}
+	int Get_Ladder_Index() {return LadderIndex;}
 };
 
 #endif
diff -uwr sourceold/scripts/TransitionGameObjDef.h source/scripts/TransitionGameObjDef.h
--- sourceold/scripts/TransitionGameObjDef.h	2011-10-11 21:41:33.498046800 +0800
+++ source/scripts/TransitionGameObjDef.h	2012-05-06 16:37:05.377843700 +0800
@@ -16,7 +16,7 @@
 class TransitionDataClass
 {
 public:
-	enum TriggerType {
+	enum StyleType {
 		LADDER_EXIT_TOP,
 		LADDER_EXIT_BOTTOM,
 		LADDER_ENTER_TOP,
@@ -28,11 +28,11 @@
 		VEHICLE_ENTER,
 		VEHICLE_EXIT,
 	};
-	TriggerType triggerType; // 0000
-	OBBoxClass triggerZone; // 0004
-	StringClass animationName; // 0040
-	Matrix3D characterTransform; // 0044
-	TransitionDataClass() : triggerType(LADDER_EXIT_TOP)
+	StyleType Type; // 0000
+	OBBoxClass TriggerZone; // 0004
+	StringClass AnimationName; // 0040
+	Matrix3D CharacterTransform; // 0044
+	TransitionDataClass() : Type(LADDER_EXIT_TOP)
 	{
 	}
 	bool Save(ChunkSaveClass &csave);
@@ -40,9 +40,6 @@
 }; // 0074
 
 class TransitionGameObjDef : public BaseGameObjDef {
-private:
-	DECLARE_EDITABLE(TransitionGameObjDef,BaseGameObjDef);
-	DynamicVectorClass<TransitionDataClass *> Transitions;
 public:
 	TransitionGameObjDef() {};
 	~TransitionGameObjDef();
@@ -52,6 +49,14 @@
 	uint32 Get_Class_ID() const;
 	PersistClass *Create() const;
 	void Free_Transition_List();
+	DynamicVectorClass<TransitionDataClass *> &Get_Transitions() {return Transitions;}
+	const DynamicVectorClass<TransitionDataClass *> &Get_Transitions() const {return Transitions;}
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
+	DECLARE_EDITABLE(TransitionGameObjDef,BaseGameObjDef);
+private:
+	DynamicVectorClass<TransitionDataClass *> Transitions;
 	friend class PresetDump;
 };
 
diff -uwr sourceold/scripts/TransitionInstanceClass.h source/scripts/TransitionInstanceClass.h
--- sourceold/scripts/TransitionInstanceClass.h	2011-10-11 21:41:30.524414000 +0800
+++ source/scripts/TransitionInstanceClass.h	2012-04-14 04:09:46.772460900 +0800
@@ -18,16 +18,24 @@
 #include "Matrix3D.h"
 #include "ReferencerClass.h"
 #include "TransitionGameObjDef.h"
+#include "VehicleGameObj.h"
 class TransitionInstanceClass
 {
-	Matrix3D characterTransform; // 0000
-	OBBoxClass triggerZone; // 0030
-	ReferencerClass vehicle; // 006C
-	TransitionDataClass* definition; // 007C
-	int ladderId; // 0080
+private:
+	Matrix3D CharacterTransform; // 0000
+	OBBoxClass TriggerZone; // 0030
+	ReferencerClass Vehicle; // 006C
+	TransitionDataClass* Definition; // 007C
+	int LadderId; // 0080
 public:
-	int Get_Type() {return definition->triggerType;}
+	TransitionInstanceClass();
+	~TransitionInstanceClass();
+	void Start(SoldierGameObj *soldier);
+	bool Check(SoldierGameObj *soldier, bool b);
 	static void End(SoldierGameObj *,TransitionCompletionDataStruct *);
+	void Set_Parent_Transform(Matrix3D const &tm);
+	TransitionDataClass::StyleType Get_Type() {return Definition->Type;}
+	void Set_Vehicle(VehicleGameObj *obj) {Vehicle = obj;}
 }; // 0084
 
 #endif
\ No newline at end of file
Only in source/scripts: TwiddlerClass.cpp
diff -uwr sourceold/scripts/TwiddlerClass.h source/scripts/TwiddlerClass.h
--- sourceold/scripts/TwiddlerClass.h	2011-10-11 21:41:14.732421800 +0800
+++ source/scripts/TwiddlerClass.h	2012-05-06 16:37:05.393468700 +0800
@@ -26,6 +26,9 @@
 	uint32 Get_Class_ID() const {return 57344;}
 	virtual uint32 Get_Indirect_Class_ID() const {return m_IndirectClassID;}
 	virtual void Set_Indirect_Class_ID(uint32 class_id) {m_IndirectClassID = class_id;}
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE( TwiddlerClass, DefinitionClass );
 private:
 	uint32 m_IndirectClassID;
diff -uwr sourceold/scripts/VehicleFactoryGameObj.h source/scripts/VehicleFactoryGameObj.h
--- sourceold/scripts/VehicleFactoryGameObj.h	2011-10-21 09:32:27.700195300 +0800
+++ source/scripts/VehicleFactoryGameObj.h	2012-05-23 15:31:23.082031200 +0800
@@ -23,7 +23,7 @@
 	~VehicleFactoryGameObj (void);
 	virtual	void							Init( void );
 	void										Init (const VehicleFactoryGameObjDef & definition);
-	const VehicleFactoryGameObjDef &	Get_Definition (void) const;
+	SCRIPTS_API const VehicleFactoryGameObjDef &	Get_Definition (void) const;
 	VehicleFactoryGameObj *			As_VehicleFactoryGameObj (void)	{ return this; }
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
@@ -44,6 +44,11 @@
 	void					Export_Rare (BitStreamClass &packet);
 	static void			Set_Max_Vehicles_Per_Team(int max)		{ MaxVehiclesPerTeam = max; }
 	static int			Get_Max_Vehicles_Per_Team(void)			{ return MaxVehiclesPerTeam; }
+	void Set_Busy(bool busy)
+	{
+		IsBusy = busy;
+		Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE,true);
+	}
 protected:
 	void					Load_Variables (ChunkLoadClass &cload);
 	virtual void		Destroy_Blocking_Objects (void);
diff -uwr sourceold/scripts/VehicleFactoryGameObjDef.h source/scripts/VehicleFactoryGameObjDef.h
--- sourceold/scripts/VehicleFactoryGameObjDef.h	2011-10-11 21:40:57.450195300 +0800
+++ source/scripts/VehicleFactoryGameObjDef.h	2012-05-06 16:37:05.403234400 +0800
@@ -30,6 +30,9 @@
 	float									Get_Total_Building_Time(void) const { return TotalBuildingTime; }
 	bool									Get_Flying_Waypaths_Enabled() const { return EnableFlyingWaypaths; }
 	bool									Get_Build_Ground_Only() const { return BuildGroundOnly; }
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+#endif
 	DECLARE_EDITABLE (VehicleFactoryGameObjDef, BuildingGameObjDef);
 protected:
 	void					Load_Variables (ChunkLoadClass &cload);
diff -uwr sourceold/scripts/VehicleGameObjDef.h source/scripts/VehicleGameObjDef.h
--- sourceold/scripts/VehicleGameObjDef.h	2012-02-13 17:16:25.394929700 +0800
+++ source/scripts/VehicleGameObjDef.h	2012-05-06 16:37:05.414953100 +0800
@@ -43,7 +43,14 @@
 	virtual PersistClass *					Create( void ) const ;
 	virtual bool								Save( ChunkSaveClass &csave );
 	virtual bool								Load( ChunkLoadClass &cload );
+#ifdef TT_EXPORTS
+	virtual	void	On_Post_Load( void );
+#endif
 	virtual const PersistFactoryClass &	Get_Factory( void ) const;
+#ifdef DDBEDIT
+	virtual void                        Dump (FileClass &file);
+	virtual void                        DumpPhys (FileClass &file);
+#endif
 	DECLARE_EDITABLE( VehicleGameObjDef, SmartGameObjDef );
 	DynamicVectorClass<TransitionDataClass*> *					Get_Transition_List( void ) { return &Transitions; }
 	const DynamicVectorClass<TransitionDataClass*> &			Get_Transition_List( void ) const { return Transitions; }
@@ -54,6 +61,7 @@
 	VehicleType Get_Type() const {return Type;}
 	const StringClass &Get_Fire0_Anim() const {return Fire0Anim;}
 	const StringClass &Get_Fire1_Anim() const {return Fire1Anim;}
+	bool Get_Build_At_Ground() const {return BuildAtGround;}
 protected:
 	VehicleType									Type;
 	StringClass									TypeName;
@@ -76,6 +84,8 @@
 	int NodDestroyReportID;
 	bool CanBeStolen;
 	bool AllowStealthWhileEmpty;
+	bool BuildAtGround;
+	bool DualAim;
 	friend	class								VehicleGameObj;
 	friend class PresetDump;
 }; // size: 324
